C
      SUBROUTINE RUNPROG(INFILE,DATAFILE,OUTFILE,TEMPFILE,ERRCODE)
      !MS$ATTRIBUTES stdcall, DLLEXPORT :: RUNPROG
      !MS$ATTRIBUTES STDCALL,REFERENCE :: INFILE
      !MS$ATTRIBUTES STDCALL,REFERENCE :: DATAFILE
      !MS$ATTRIBUTES STDCALL,REFERENCE :: OUTFILE
      !MS$ATTRIBUTES STDCALL,REFERENCE :: TEMPFILE
      !MS$ATTRIBUTES REFERENCE :: ERRCODE
	INTEGER NDS,IMCYCLE,IFINISH,ERRCODE
	CHARACTER*64 INFILE,OUTFILE,TEMPFILE,DATAFILE
      COMMON/DLLCOM/IDSZ,IRS
      CALL STARTPROG(NDS,0,0,INFILE,DATAFILE,OUTFILE,TEMPFILE,ERRCODE)
      IF (ERRCODE.EQ.0) THEN
        IMCYCLE = 1
        DO WHILE ((IFINISH.EQ.0).AND.(ERRCODE.EQ.0))
	     CALL ITER(NDS,IRS,IMCYCLE,IFINISH,ERRCODE)
           IMCYCLE = IMCYCLE + 1
        ENDDO
        IF (ERRCODE.EQ.0) CALL CLOSEPROG(NDS,ERRCODE)
      ENDIF
      RETURN
      END

      INTEGER FUNCTION IYIELDTOOTHERS()
	USE MSFWIN
	type (T_MSG) lpMsg
	LOGICAL(4) RET
	INTEGER P1,P2,P3,R1
	P1 = 0
	P2 = 0
	P3 =0
	R1 = 1
	IYIELDTOOTHERS = 0 
      DO WHILE (PeekMessage(lpMsg, p1, p2, p3, r1))
       IF (lpMSG.message.ne.18) THEN
		RET=TranslateMESSAGE(lpMSG)
	    RET=DISPATCHMESSAGE(lpMSG)
	 ELSE
		IYIELDTOOTHERS = 99
	 ENDIF
	ENDDO
      END
C
      subroutine STARTPROG(NDS,IDSIZE,IRSIZE,INFILE,DATAFILE,OUTFILE,
     *                     TEMPFILE,ERRCODE)
      !MS$ATTRIBUTES stdcall, DLLEXPORT :: STARTPROG
      !MS$ATTRIBUTES STDCALL,REFERENCE :: INFILE
      !MS$ATTRIBUTES STDCALL,REFERENCE :: DATAFILE
      !MS$ATTRIBUTES STDCALL,REFERENCE :: OUTFILE
      !MS$ATTRIBUTES STDCALL,REFERENCE :: TEMPFILE
      !MS$ATTRIBUTES REFERENCE :: IDSIZE
      !MS$ATTRIBUTES REFERENCE :: IRSIZE
      !MS$ATTRIBUTES REFERENCE :: ERRCODE
	!MS$ATTRIBUTES REFERENCE :: NDS
      include 'param.inc'
      CHARACTER FNAME*64,INFILE*64,TEMPFILE*64,OUTFILE*64,DATAFILE*64
      CHARACTER TCHAR,FTEMP*64
      COMMON/DLLCOM/IDSZ,IRS
	COMMON/FILEINT/LC,FNAME,FTEMP
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES
	INTEGER NDS,LC,ERRCODE,I,IDSIZE,IRSIZE
      IDSZ = IDSIZE
      IRS = IRSIZE
      IF (IDSIZE.EQ.0) IDSZ = 8000
      IF (IRSIZE.EQ.0) IRS  = 4000
	ERRCODE = 0
      FNAME = DATAFILE
	LC = LEN_TRIM(FNAME)-1
	IF (LC.LE.0) GOTO 23
c
      LT = LEN_TRIM(INFILE)-1
	IF (LT.LE.0) GOTO 20
      open(unit=5,file=INFILE(1:LT),err=20,status='OLD')                         !input file
c
      LT = LEN_TRIM(OUTFILE)-1
	IF (LT.LE.0) GOTO 21
      open(unit=6,file=OUTFILE(1:LT),err=21,status='UNKNOWN')                    !output file
c
      I = 1
      DO WHILE ((TEMPFILE(I:I).NE.' ').AND.(I.LT.LEN(TEMPFILE))) 
       TCHAR = TEMPFILE(I:I)
	 I = I + 1
      ENDDO
	FTEMP = TEMPFILE
	LT = I - 2                 
	IF (LT.LE.0) GOTO 22
      open(unit=7,file=TEMPFILE(1:LT)//'.lst',err=22,status='UNKNOWN')                               !for console output
C      open(unit=8,file=TEMPFILE(1:LT)//'.upd',err=22,status='UNKNOWN')           !updated file
C      open(unit=20,file=TEMPFILE(1:LT)//'.fou',err=22,status='UNKNOWN')          !fourier file
C      open(unit=9,file=TEMPFILE(1:LT)//'.plt',err=22,status='UNKNOWN')
c
	CALL INPTR(NDS,IDSZ,IRS,ERRCODE)
      CLOSE(UNIT=5,ERR=24)
      IF (ERRCODE.NE.0) THEN                                                      !RETURNS NDS
C         CLOSE(UNIT=5)
          RETURN                                                                      
      ENDIF
      IF (NXT.NE.0) THEN
        open(unit=8,file=TEMPFILE(1:LT)//'.upd',ERR=22,status='UNKNOWN')              !updated file
      ENDIF
      IF (IFOUR.NE.0) THEN
	 open(unit=20,file=TEMPFILE(1:LT)//'.fou',ERR=22,status='UNKNOWN')             !fourier file
      ENDIF
      IF (IPL2.NE.0) THEN
        open(unit=9,file=TEMPFILE(1:LT)//'.plt',ERR=22,status='UNKNOWN')
      ENDIF
C      CLOSE(UNIT=5,ERR=24)
      DO 10 I=1,NDS                                   
   10     CALL ASSIGN(I,IDSZ,IRS,errcode)                                                  !ASSIGN REFLECTION TO DATA
      WRITE(7,*) 'Starting refinement...'
      LC = LT                                                                     !WRITE OVER LC
	RETURN
   20 ERRCODE = 1
      RETURN
   21 ERRCODE = 2
      RETURN
   22 ERRCODE = 3
      RETURN
   23 ERRCODE = 6
      RETURN
   24 ERRCODE = 5
      RETURN
	END

      SUBROUTINE ITERATION(NDS,IMCYCLE,IFINISH,ERROR)
      !MS$ATTRIBUTES stdcall,DLLEXPORT :: ITERATION
      !MS$ATTRIBUTES REFERENCE :: NDS
	!MS$ATTRIBUTES REFERENCE :: IMCYCLE
	!MS$ATTRIBUTES REFERENCE :: IFINISH
	!MS$ATTRIBUTES REFERENCE :: ERROR
      COMMON/DLLCOM/IDSZ,IRS
	INTEGER NDS,IMCYCLE,IFINISH,ERROR
      CALL ITER(NDS,IRS,IMCYCLE,IFINISH,ERROR)
      RETURN
	END
c
      SUBROUTINE CLOSEPROG(NDS,ERRCODE)
      !MS$ATTRIBUTES stdcall,DLLEXPORT :: CLOSEPROG
	!MS$ATTRIBUTES REFERENCE :: ERRCODE
	!MS$ATTRIBUTES REFERENCE :: NDS
	INCLUDE 'param.inc'
      INTEGER NDS,I,ERRCODE,LC,ERR2,IDSZ
      COMMON/DLLCOM/IDSZ,IRS
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES
      CHARACTER FNAME*64,FTEMP*64
      COMMON/FILEINT/LC,FNAME,FTEMP
	ERRCODE = 0
      write(7,*) 'Finishing refinement...'
      DO 11 I=1,NDS                                       
   11     CALL EXPUT(I,IDSZ,NDS)
      IF ((RADMIN.NE.0).OR.(RADMAX.NE.0.0)) THEN
          WRITE(7,*) 'Writing bond file...'
          open(unit=10,file=FTEMP(1:lc)//'.dst',ERR=20,status='UNKNOWN')         !DISTANCES
          OPEN(UNIT=11,file=FTEMP(1:LC)//'.ang',ERR=20,STATUS='UNKNOWN')
          DO 1000 I=1,NPHASE
 1000         CALL BONDGEN(I,RADMIN,RADMAX)
      ENDIF
	goto 21
   20 ERRCODE = 4
   21 CONTINUE
c   CALL DALCMEMORY(ERR2)
c      IF (ERRCODE.EQ.0) ERRCODE = ERR2
      close(unit =2)
      close(unit =4)
      close(unit =5)
      close(unit =6)
      close(unit =7)
      close(unit =8)
      close(unit =9)
      close(unit =10)
      close(unit =11)
      close(unit =20)
      close(unit =21)
	RETURN
      END            
c
      SUBROUTINE CLOSEMEM(ERRCODE)
      !MS$ATTRIBUTES stdcall,DLLEXPORT :: CLOSEMEM
	!MS$ATTRIBUTES REFERENCE :: ERRCODE
      INTEGER ERRCODE
	CALL DALCMEMORY(ERRCODE)
	RETURN
      END            
c         Retrieve Bragg values
      Subroutine GETINFO(NDS,RBRAGG1,RBRAGG2,GOF,NPR,IPAR,VPAR,EPAR)
      !MS$ATTRIBUTES stdcall,DLLEXPORT :: GETINFO
	!MS$ATTRIBUTES REFERENCE :: NDS
	!MS$ATTRIBUTES REFERENCE :: RBRAGG1
	!MS$ATTRIBUTES REFERENCE :: RBRAGG2
	!MS$ATTRIBUTES REFERENCE :: GOF
	!MS$ATTRIBUTES REFERENCE :: NPR
	!MS$ATTRIBUTES REFERENCE :: IPAR
	!MS$ATTRIBUTES REFERENCE :: VPAR
	!MS$ATTRIBUTES REFERENCE :: EPAR
      include 'param.inc'
      COMMON/G2/S1(MAXDS),S2(MAXDS),S3(MAXDS),D1(MAXDS),D2(MAXDS),
     &          R1(MAXDS),R2(MAXDS),R3(MAXDS),DWD(MAXDS),WDWD(MAXDS),
     &          R1TOT,R2TOT,R3TOT
      COMMON/PARVAL/IPNUM(MSZ),PVAL(MSZ),PERR(MSZ),NPAR
      INTEGER NPR,IPAR(MSZ)
      REAL RBRAGG1,RBRAGG2,GOF,VPAR(MSZ),EPAR(MSZ)
      RBRAGG1 = R2(NDS)
      RBRAGG2 = R3(NDS)
      GOF = S2(NDS)
	NPR = NPAR
	DO I =1,NPR
          IPAR(I) = IPNUM(I)
	    VPAR(I) = PVAL(I)
          EPAR(I) = PERR(I)
	ENDDO
      return
      end
C
      SUBROUTINE GETSTATUS(PERC)
      !MS$ATTRIBUTES stdcall,DLLEXPORT :: GETSTATUS
	!MS$ATTRIBUTES REFERENCE :: PERC
      REAL PERCENT,PERC
      COMMON/RUNNING/PERCENT
	PERC = PERCENT
	RETURN
	END
c
      Subroutine PUTINFO(GLB1,PAR1,XL1)
      !MS$ATTRIBUTES stdcall,DLLEXPORT :: PUTINFO
	!MS$ATTRIBUTES STDCALL,REFERENCE :: GLB1
	!MS$ATTRIBUTES STDCALL,REFERENCE :: PAR1
	!MS$ATTRIBUTES STDCALL,REFERENCE :: XL1
      include 'param.inc'
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,11),LP(NATS,11),
     *A(NATS,11),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2)
      REAL GLB1(MAXGP),PAR1(NUPH*MAXAP),XL1(NATS*11)
      INTEGER I,J
      DO I =1,MAXGP
	    GLB(i) = GLB1(i)
	ENDDO
      DO I=1,NUPH
      DO J=1,MAXAP
          PAR(I,J) = PAR1(J+(I-1)*MAXAP) 
	ENDDO
      ENDDO
      DO I=1,NATS
      DO J=1,11
          XL(I,J) = XL1(J+(I-1)*11)
	ENDDO
	ENDDO
      return
      end
C
c		set a parameter value
      Subroutine SETPAR(IHN,IPN,IAN,IVN,VALUE,ERRCODE)
      !MS$ATTRIBUTES stdcall,DLLEXPORT :: SETPAR
	!MS$ATTRIBUTES REFERENCE :: IHN
	!MS$ATTRIBUTES REFERENCE :: IPN
	!MS$ATTRIBUTES REFERENCE :: IAN
	!MS$ATTRIBUTES REFERENCE :: IVN
	!MS$ATTRIBUTES REFERENCE :: VALUE
	!MS$ATTRIBUTES REFERENCE :: ERRCODE
      include 'param.inc'
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,11),LP(NATS,11),
     *A(NATS,11),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2)
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      COMMON/COEFF/AC(MAXDS,10,MAXFF),POSI(MFCO,MAXFF),SCAT(MFCO,MAXFF),
     *DFP(MAXDS,MAXFF,2),DFPP(MAXDS,MAXFF)
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES
      COMMON/F2/SIGCEL(NUPH,6),SIGATOM(NATS,3)
      INTEGER IVN,IHN,IPN,IAN,ERRCODE
	REAL VALUE
	ERRCODE = 250
C		HISTOGRAM VALUES
	IF ((IPN.EQ.0).AND.(IAN.EQ.0).AND.(IHN.NE.0).AND.(IVN.NE.0)) THEN
	   IF ((IHN.LE.MAXDS).AND.(IHN.GE.1).AND.(IVN.LE.MAXIGL).AND.
     *      (IVN.GE.1)) THEN 
             GLB(IVN+(IHN-1)*MAXIGL) = VALUE
	       ERRCODE = 0
	   ELSE
		   ERRCODE = 251
	   ENDIF
	ENDIF 
C		PHASE VALUES
	IF ((IPN.NE.0).AND.(IAN.EQ.0).AND.(IHN.EQ.0).AND.(IVN.NE.0)) THEN
	   IF ((IPN.LE.NPHASE).AND.(IPN.GE.1).AND.(IVN.LE.MAXIPAR).AND.
     *      (IVN.GE.1)) THEN 
             PAR(IPN,IVN) = VALUE
	       ERRCODE = 0
	   ELSE
		   ERRCODE = 251
	   ENDIF
	ENDIF 
C		ATOM VALUES
	IF ((IPN.NE.0).AND.(IAN.NE.0).AND.(IHN.EQ.0).AND.(IVN.NE.0)) THEN
         NA = 0
	   DO I=1,IPN-1
             NA = NA + ABS(NATOM(I))
	   ENDDO
	   IF ((IPN.LE.NPHASE).AND.(IPN.GE.1).AND.(IVN.LE.11).AND.
     *      (IVN.GE.1).AND.(IAN.LE.ABS(NATOM(IPN))).AND.(IAN.GE.1)) THEN 
	      XL(NA+IAN,IVN) = VALUE
	      ERRCODE = 0
	   ELSE
		   ERRCODE = 251
	   ENDIF
	ENDIF 
C		SCATTERING VALUES
	IF ((IPN.EQ.99).AND.(IAN.NE.0).AND.(IHN.NE.0).AND.(IVN.NE.0)) THEN
		IF ((JOBTYP(IHN).EQ.2).OR.(JOBTYP(IHN).GE.4)) THEN
			DFP(IHN,IAN,2)=VALUE
		ELSE
		    DFP(IHN,IAN,1)=VALUE
		ENDIF
	    IF (IVN.EQ.2) THEN 
			DFPP(IHN,IAN)=VALUE
			ERRCODE = 0
	    ENDIF
	ENDIF 
      RETURN
      END
C
c		GET a parameter value
      Subroutine GETPAR(IHN,IPN,IAN,IVN,VALUE,EVALUE,ERRCODE)
      !MS$ATTRIBUTES stdcall,DLLEXPORT :: GETPAR
	!MS$ATTRIBUTES REFERENCE :: IHN
	!MS$ATTRIBUTES REFERENCE :: IPN
	!MS$ATTRIBUTES REFERENCE :: IAN
	!MS$ATTRIBUTES REFERENCE :: IVN
	!MS$ATTRIBUTES REFERENCE :: VALUE
	!MS$ATTRIBUTES REFERENCE :: EVALUE
	!MS$ATTRIBUTES REFERENCE :: ERRCODE
      include 'param.inc'
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,11),LP(NATS,11),
     *A(NATS,11),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2)
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      COMMON/COEFF/AC(MAXDS,10,MAXFF),POSI(MFCO,MAXFF),SCAT(MFCO,MAXFF),
     *DFP(MAXDS,MAXFF,2),DFPP(MAXDS,MAXFF)
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES
      COMMON/PARVAL/IPNUM(MSZ),PVAL(MSZ),PERR(MSZ),NPAR
      COMMON/F2/SIGCEL(NUPH,6),SIGATOM(NATS,3)
      COMMON/DC/SAVE(NUPH,6),NSAVE
      INTEGER IVN,IHN,IPN,IAN,ERRCODE
	REAL VALUE
	ERRCODE = 250
C		HISTOGRAM VALUES
	EVALUE = 0.0
      IF ((IPN.EQ.0).AND.(IAN.EQ.0).AND.(IHN.NE.0).AND.(IVN.NE.0)) THEN
	   VALUE = GLB(IVN+(IHN-1)*MAXIGL)
	   ERRCODE = 0
	ENDIF 
C		PHASE VALUES
	IF ((IPN.NE.0).AND.(IAN.EQ.0).AND.(IHN.EQ.0).AND.(IVN.NE.0)) THEN
         VALUE = PAR(IPN,IVN)
         IF ((IVN.GE.6).AND.(IVN.LE.11)) THEN
            VALUE = SAVE(IPN,IVN-5)
            EVALUE = SIGCEL(IPN,IVN-5)
	   ENDIF
         ERRCODE = 0
	ENDIF 
C		SAMPLE VALUES
	IF ((IPN.NE.0).AND.(IAN.EQ.0).AND.(IHN.NE.0).AND.(IVN.NE.0)) THEN
         VALUE = PAR(IPN,(IHN-1)*MAXIPAR+IVN)
	   ERRCODE = 0
	ENDIF 
C		ATOM VALUES
	IF ((IPN.NE.0).AND.(IAN.NE.0).AND.(IHN.EQ.0).AND.(IVN.NE.0)) THEN
         NA = 0
	   DO I=1,IPN-1
             NA = NA + ABS(NATOM(I))
	   ENDDO
	   VALUE = XL(NA+IAN,IVN)
	   ERRCODE = 0
	ENDIF 
C		SCATTERING VALUES
	IF ((IPN.EQ.99).AND.(IAN.NE.0).AND.(IHN.NE.0).AND.(IVN.NE.0)) THEN
	   IF (IVN.EQ.1) THEN 
			IF ((JOBTYP(IHN).EQ.2).OR.(JOBTYP(IHN).GE.4)) THEN
				VALUE = DFP(IHN,IAN,2)
			ELSE
			    VALUE =DFP(IHN,IAN,1)
			ENDIF
			ERRCODE = 0
	   ENDIF
	   IF (IVN.EQ.2) THEN 
			VALUE = DFPP(IHN,IAN)
			ERRCODE = 0
	   ENDIF
	ENDIF 
      RETURN
      END
c		GET a parameter value
      Subroutine GETPAR2(IPARN,VALUE,EVALUE,ERRCODE)
      !MS$ATTRIBUTES stdcall,DLLEXPORT :: GETPAR2
	!MS$ATTRIBUTES REFERENCE :: IPARN
	!MS$ATTRIBUTES REFERENCE :: VALUE
	!MS$ATTRIBUTES REFERENCE :: EVALUE
	!MS$ATTRIBUTES REFERENCE :: ERRCODE
      include 'param.inc'
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,11),LP(NATS,11),
     *A(NATS,11),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2)
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      COMMON/COEFF/AC(MAXDS,10,MAXFF),POSI(MFCO,MAXFF),SCAT(MFCO,MAXFF),
     *DFP(MAXDS,MAXFF,2),DFPP(MAXDS,MAXFF)
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES
      COMMON/PARVAL/IPNUM(MSZ),PVAL(MSZ),PERR(MSZ),NPAR
      INTEGER IPARN,ERRCODE
	REAL VALUE,EVALUE
	ERRCODE = 250
      IF ((IPARN.GT.0).AND.(IPARN.LE.NPAR)) THEN
		VALUE = PVAL(IPARN)
		EVALUE = PERR(IPARN)
		ERRCODE = 0   
	ENDIF
      RETURN
      END
C      1              ZERO
C      2              BACKGROUND 0
C      3              BACKGROUND 1
C      4              BACKGROUND 2
C      5              BACKGROUND 3
C      6              BACKGROUND 4
C      7              BACKGROUND 5
C      8              BACKRGOUND 6      ]
C      9              BACKRGOUND 7      ]
C     10              BACKRGOUND 8      ] not used if BFLAG = 0
C     11              BACKRGOUND 9      ]
C     12              BACKRGOUND 10     ]
C     13              BACKRGOUND 11     ]
C     14              HISTOGRAM SCALE
C     15              WAVELENGTH 1 OR DIFC
c     16              DIFA (CURRENTLY NOT WAVELENGTH 2)
C     MAXGP = 16
C
C
C             This is repeated for every histogram
C     Note: The Phase Scale, Iso Thermal, a,b,c,al,be,gam are applicable only for the first histogram
C  PAR #              PURPOSE
C  -----------------------------------------
C      1              PHASE SCALE
C      2              ISOTROPIC THERMAL
C      3              U
C      4              V
C      5              W
C      6              a
C      7              b
C      8              c
C      9              alpha
C     10              beta
C     11              gamma
C     12              PREFFERRED ORIETNATION
C     13              R ABSORPTION VALUE OR FLAT PLATE P0
C     14              ASYMMETRY
C     15              GAM-0
C     16              GAM-1
C     17              GAM-2
C     18              EXTINCTION
C     19              Uaniso
C     20                            not presently used
C     21              TOF ALPHA-1
C     22              TOF ALPHA-2
C     23              TOF BETA-1
C     24              TOF BETA-2
C     25              FLAT PLATE ABSORPTION C1
C     26              FLAT PLATE ABSORPTION C2
C     MAXIPAR = 26
C
c         Retrieve plotting information
      Subroutine GETPLOT(JDS,AFIN,ERRCODE,YVAL,YCVAL,IREF,REF)
      !MS$ATTRIBUTES stdcall,DLLEXPORT :: GETPLOT
	!MS$ATTRIBUTES REFERENCE :: JDS
	!MS$ATTRIBUTES REFERENCE :: AFIN
	!MS$ATTRIBUTES REFERENCE :: ERRCODE
	!MS$ATTRIBUTES REFERENCE :: YVAL
	!MS$ATTRIBUTES REFERENCE :: YCVAL
	!MS$ATTRIBUTES REFERENCE :: IREF
	!MS$ATTRIBUTES REFERENCE :: REF
      include 'param.inc'
      COMMON/DLLCOM/IDSZ,IRS
      REAL, Pointer::  Y(:,:),YC(:,:),BK(:,:),WT(:,:)
      INTEGER, Pointer::  NPTS(:),KR(:,:)
      COMMON/DATAX/Y,YC,KR,BK,NPTS,WT
      INTEGER, Pointer::  IREFS(:,:),IC(:,:)
      REAL, POINTER:: REFS(:,:,:),MLT(:,:)
      COMMON/REFLS/IREFS,REFS,MLT,IC
      COMMON/G1/THMIN(MAXDS),STEP(MAXDS),THMAX(MAXDS),U(MAXDS),
     &  V(MAXDS),W(MAXDS),LAMDA(MAXDS,2),TMV(MAXDS),CTHM(MAXDS),
     &  RLIM,SB,WDT(MAXDS),UU(MAXDS),VV(MAXDS),WW(MAXDS),FFLIM(MAXDS),                              
     &  IABSCOR(MAXDS)
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,11),LP(NATS,11),
     *A(NATS,11),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2)
C
      INTEGER JDS,I,ERRCODE,ICZ,IREF(IRS),NLPTS,AFIN
      REAL YVAL(IDSZ),YCVAL(IDSZ),REF(IRS),TH,SS,THT
	ERRCODE = 0
	IF (JDS.GT.MAXDS) GOTO 20
C			IF AFTER FINISH WE MUST DO THINGS SLIGHTLY DIFFERENTLY
      IF (AFIN.EQ.0) THEN
	 NLPTS = (AHIGH(JDS,NEXCRG(JDS))- ALOW(JDS,NEXCRG(JDS)))/STEP(JDS)
     &            +1.5
       THT=ALOW(JDS,NEXCRG(JDS)-1) - STEP(JDS)
       TH=AHIGH(JDS,NEXCRG(JDS)) + STEP(JDS)
	 SS = STEP(JDS)
       NP=(THT-TH)/SS + 1.5
       DO I=1,NP
          YVAL(I) = Y(JDS,I+NLPTS)
          YCVAL(I) = YC(JDS,I+NLPTS)+BK(JDS,I+NLPTS)
       ENDDO
	ELSE
       NP = (THMAX(JDS)-THMIN(JDS))/STEP(JDS) + 1.5
       DO I=1,NP
          YVAL(I) = Y(JDS,I)
          YCVAL(I) = YC(JDS,I)
       ENDDO
      ENDIF
C
      ICZ = 0
      DO I=1,NPHASE
          ICZ = ICZ + IC(JDS,I)
	ENDDO
      DO I =1,ICZ
          IREF(I) = IREFS(JDS,I)
          IF (JOBTYP(JDS).LE.4) THEN
	       REF(I) = REFS(JDS,I,2)+GLB((JDS-1)*MAXIGL+1)
          ELSE
	       REF(I) = REFS(JDS,I,2)
          ENDIF
     	ENDDO
      RETURN
   20 ERRCODE = 10
      RETURN
      END
c
      Subroutine GETPLOTINFO(JDS,NP,ICZ,THM,SS)
      !MS$ATTRIBUTES stdcall,DLLEXPORT :: GETPLOTINFO
	!MS$ATTRIBUTES REFERENCE :: JDS
	!MS$ATTRIBUTES REFERENCE :: NP
	!MS$ATTRIBUTES REFERENCE :: ICZ
	!MS$ATTRIBUTES REFERENCE :: THM
	!MS$ATTRIBUTES REFERENCE :: SS
      include 'param.inc'
      REAL, Pointer::  Y(:,:),YC(:,:),BK(:,:),WT(:,:)
      INTEGER, Pointer::  NPTS(:),KR(:,:)
      COMMON/DATAX/Y,YC,KR,BK,NPTS,WT
      INTEGER, Pointer::  IREFS(:,:),IC(:,:)
      REAL, POINTER:: REFS(:,:,:),MLT(:,:)
      COMMON/REFLS/IREFS,REFS,MLT,IC
      COMMON/G1/THMIN(MAXDS),STEP(MAXDS),THMAX(MAXDS),U(MAXDS),
     &  V(MAXDS),W(MAXDS),LAMDA(MAXDS,2),TMV(MAXDS),CTHM(MAXDS),
     &  RLIM,SB,WDT(MAXDS),UU(MAXDS),VV(MAXDS),WW(MAXDS),FFLIM(MAXDS),                              
     &  IABSCOR(MAXDS)
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,11),LP(NATS,11),
     *A(NATS,11),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2)
C
      INTEGER JDS,ICZ,NP
      REAL SS,THM
c
      NP = 0
	ICZ = 0
	THM = 0.0
	SS = 0.0
      IF (JDS.GT.MAXDS) GOTO 20
      NLPTS = (AHIGH(JDS,NEXCRG(JDS))- ALOW(JDS,NEXCRG(JDS)))/STEP(JDS)
     &            +1.5
      THT=ALOW(JDS,NEXCRG(JDS)-1) - STEP(JDS)
      THM=AHIGH(JDS,NEXCRG(JDS)) + STEP(JDS)
	SS = STEP(JDS)
      NP=(THT-THM)/SS + 1.5
C
      ICZ = 0
      DO I=1,NPHASE
          ICZ = ICZ + IC(JDS,I)
	ENDDO
   20 RETURN
      END
C
c         Retrieve plotting information
      Subroutine GETFOUR(JDS,IPH,ISECT,ISLICE,RS,ERRCODE)
      !MS$ATTRIBUTES stdcall,DLLEXPORT :: GETFOUR
	!MS$ATTRIBUTES REFERENCE :: JDS
	!MS$ATTRIBUTES REFERENCE :: IPH
	!MS$ATTRIBUTES REFERENCE :: ISECT
	!MS$ATTRIBUTES REFERENCE :: ISLICE
	!MS$ATTRIBUTES REFERENCE :: RS
	!MS$ATTRIBUTES REFERENCE :: ERRCODE
      include 'param.inc'
      INTEGER JDS,IPH,ISECT,ISLICE,ERRCODE
	REAL RS(0:127,0:127)
C
	ERRCODE = 0
c      CALL FOURIER(JDS,IPH,128,32,ISECT,1,2,ISLICE,RS)      
      RETURN
      END
C
c
      Subroutine QUICKCLOSE
      !MS$ATTRIBUTES stdcall,DLLEXPORT :: QUICKCLOSE
   21 close(unit =2)
      close(unit =4)
      close(unit =5)
      close(unit =6)
      close(unit =7)
      close(unit =8)
      close(unit =9)
      close(unit =10)
      close(unit =20)
      close(unit =21)
	RETURN
      END            

	FUNCTION IGETSYSTEM()
	IGETSYSTEM = IYIELDTOOTHERS()
	RETURN
	END
